local me,ns=...
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local bs=LibStub("LibBattleScan")
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local AceGUI=LibStub("AceGUI-3.0")
local C=LibStub("AlarCrayon-3.0"):GetColorTable()
local CB=LibStub("LibCandyBar-3.0",true) -- Optional
local LA=LibStub("LibArrow-1.0")
local bg='TP'
local store
local large
local hcWidget
local acWidget
local aArrow
local hArrow
local BgBar
local lastgroup


local aCarrier=""
local hCarrier=""
--[[
Carrier is trackable in 45 seconds
Flag respawns in 25
--]]
local classes={
	WARRIOR=0,
	MAGE=1,
	ROGUE=2,
	DRUID=3,
	HUNTER=4,
	SHAMAN=5,
	PRIEST=6,
	WARLOCK=7,
	PALADIN=8,
	DEATHKNIGHT=9
} 
local m1='Enemies incoming from'
local m2='Enemies in'
local m3=' carrier is'
local m4=' carrier exits from'
local messages={
	CarrierExits={
		MDF={L["Middlefield"],m3},
		RMP={L["Ramp"],m4},
		GY={L["Graveyard"],m4},
		TNL={L["Tunnel"],m4}
	},
	Enemies={
		TER={L["Terrace"],m1},
		FLG={L["Flag Room"],m2},
		RF={L["Roof"],m1},
		TNL={L["Tunnel"],m1}
	},
	CarrierIs={
		ORF={L["Our Roof"],m3},
		OGY={L["Our Graveyard"],m3},
		OFR={L["Our Flag Room"],m3},
		TRF={L["Their Roof"],m3},
		TGY={L["Their Graveyard"],m3},
		TFR={L["Their Flag Room"],m3}
	}
}
local messageorder={
	'RMP','GY','TNL','MDF','TER','FLG','RF','ORF','OGY','OFR','TRF','TGY','OTR'
}
local function IndexToTexCoord(i,l)
	i=i or 5
	l=l or 14
	local c=i%l
	local d=1/l
	local r=i-c
	local r=r/l
	return  c*d,c*d+d,r*d,r*d+d
end	
local module=abh:GetModule(bg)
local function Carrier(self,event,button,...)
	if (button =="RightButton") then
		local h=self:GetUserData("health") or 100
		local c=self:GetUserData("class") or 'unk'
		local r=self:GetUserData("race") or 'unk'
		local f=self:GetUserData("faction") or 'unk'
		local n=self:GetTitle() or ''
		local e=GetTime()-(self:GetUserData('updated') or 0)
		local formato=e<5 and L["%s carrier: %s (%s %s Health: %s%%)"] or L["%s carrier: %s (%s %s Last known health: %s%%)"]
		abh:Message(format(formato,f,n,r,c,h))
	end
end

function module:HeartBeat()
	local at=tonumber(acWidget:GetUserData("taken")) or -1
	local ht=tonumber(hcWidget:GetUserData("taken")) or -1
	if (ht > 0 and ht >0) then
		if not damagecounterstart then
			damagecounterstart=max(ht,at)
		end
	else
		damagecounterstart=nil
	end
	if (damagecounterstart) then
		local elapsed=GetTime()-damagecounterstart
		local damage="100%"
		if (elapsed >900) then
			elapsed=0
		elseif elapsed > 600 then
			elapsed=600-elapsed
		else
			elapsed=900-elapsed
			damaged="50%"
		end
		self:SetSingleRow("damage",format(L["%s incremented damage on carriers in %s"],damage,self:secs2min(elapsed)))
	else
		self:SetSingleRow("damage","")
	end
	if ht >0 then ht=floor(47.5 - (GetTime() -ht)) else ht=nil end
	if at >0 then at=floor(47.5 - (GetTime() -at)) else at=nil end
	local hm,am=L["Not Trackable"],L["Not Trackable"]
	self:RefreshCarrier(acWidget)	
	if (at) then 
		if (at>0) then 
			am=format(L["Carrier trackable in %d seconds"],at) 
		else
			am=L["Trackable"]
		end
	end
	self:RefreshCarrier(hcWidget)	
	if (ht) then 
		if (ht>0) then 
			hm=format(L["Carrier trackable in %d seconds"],ht) 
		else
			hm=L["Trackable"]
		end
	end
		
	self:SetFinals(am,hm)
	self:TrackFlags()
--[[	
    if (f < 525) then
    obj:SetFormattedText(L["%s incremented damage on carriers in %s"],"50%",ABH:TimeToStr(525-f))
	elseif( f < 750) then
	obj:SetFormattedText(L["%s incremented damage on carriers in %s"],"100%",ABH:TimeToStr(750-f))
    elseif (f < 755) then
	obj:SetText("100% debuff")
	end
--]] 	

end
function module:TrackFlags()
	aArrow.hide=true
	hArrow.hide=true
	for i=1, GetNumBattlefieldFlagPositions() do
		local x,y,token=GetBattlefieldFlagPosition(i)
		if (x~=0 and y~=0) then
			local arrow
			if (token=="HordeFlag") then
				arrow=aArrow
			else
				arrow=hArrow
			end
			arrow:SetLocalWaypoint(x,y)
			--arrow:AddIcon("Interface\\WorldStateFrame\\"..token)
			arrow.hide=false
		end
	end
	if aArrow.hide then aArrow:Hide() else aArrow:Show() end
	if hArrow.hide then hArrow:Hide() else hArrow:Show() end
end
function module:RefreshCarrier(obj)
	local h=tonumber(obj:GetUserData('health')) or 0
	local e=GetTime()-(tonumber(obj:GetUserData('updated')) or 0)
	local s=format(obj:GetUserData('format') or L["No carrier"], h,e)
	obj:SetTitle(s)
	local mt=obj:GetUserData("macro")
	if (not InCombatLockdown()) then
		if mt then 
			obj:Show()
			obj:SetMacrotext(mt)
		else
			obj:Hide()
		end
	end
end
function module:Init(AceGUI,storefunc)
	store=storefunc
	local large=false
	local f=self.frame
	--[[
	self:ButtonRow(f,large and L["Our carrier exits"] or L["Our carrier"],
					messages.CarrierExits,false,"Our ")
	self:ButtonRow(f,large and L["Our carrier is"] or nil,
					messages.CarrierIs,false,"Our ")
	self:ButtonRow(f,L["Enemies incoming from"],messages.Enemies,false,'')
	self:ButtonRow(f,large and L["Their carrier exits"] or L["Their carrier"],
		messages.CarrierExits,true,"Their ")
	self:ButtonRow(f,large and L["Their carrier is"] or nil,
		messages.CarrierIs,true,"Their ")
	--]]
	acWidget=AceGUI:Create("AlarCastButton")
	acWidget:SetImage("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
	acWidget:SetImageCoord(IndexToTexCoord(16,4))
	acWidget:SetTitle(L["No carrier"])
	acWidget:SetSize(16)
	acWidget:SetTitleWidth(400)
	acWidget:ClearAllPoints()
	acWidget:SetPoint("LEFT",AlwaysUpFrame2Flash,"RIGHT",40,0)
	acWidget:SetCallback("OnClick",Carrier)
	acWidget:SetUserData("faction",FACTION_ALLIANCE)
	hcWidget=AceGUI:Create("AlarCastButton")
	hcWidget:SetImage("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
	hcWidget:SetImageCoord(IndexToTexCoord(16,4))
	hcWidget:SetTitle(L["No carrier"])
	hcWidget:SetSize(16)
	hcWidget:SetTitleWidth(400)
	hcWidget:ClearAllPoints()
	hcWidget:SetPoint("LEFT",AlwaysUpFrame3Flash,"RIGHT",40,0)
	hcWidget:SetCallback("OnClick",Carrier)
	hcWidget:SetUserData("faction",FACTION_HORDE)
	self:RegisterMessage("BATTLESCAN_ALLIANCE_CARRIER")
	self:RegisterMessage("BATTLESCAN_HORDE_CARRIER")
	self:RegisterMessage("BATTLESCAN_ALLIANCE_CARRIER_HEALTH")
	self:RegisterMessage("BATTLESCAN_HORDE_CARRIER_HEALTH")
	self:RegisterMessage("BATTLESCAN_CAPTURED_FLAG","FlagTimer")
	self:SetFinals("","")
	self:SetSingleRow("damage","")
	
	aArrow=LA:NewArrow()
	aArrow:SetColor(bs:AllianceColor())
	aArrow:SetScale(0.8)
	aArrow:SetUserData("faction","Alliance")
	hArrow=LA:NewArrow()
	hArrow:SetColor(bs:HordeColor())
	hArrow:SetScale(0.8)
	hArrow:SetUserData("faction","Horde")
	if bs:FriendFaction()=="Alliance" then
		aArrow:SetTitleText(L["Our carrier"])
		hArrow:SetTitleText(L["Their carrier"])
	else
		hArrow:SetTitleText(L["Our carrier"])
		aArrow:SetTitleText(L["Their carrier"])
	end
	self:RestoreArrowPos(hArrow)
	self:RestoreArrowPos(aArrow)
	LA.RegisterCallback(self,"MOVED","StoreArrowPos")
end
function module:StoreArrowPos(event,arrow,...)
	--[===[@debug@
	print("sta",arrow:GetUserData("faction"))
	--@end-debug@]===]
	local data=abh.localdb.profile.frames['ARROW'..self.bg .. arrow:GetUserData("faction")]
	data.size=arrow:GetSize()
	data.point={...}
end
function module:RestoreArrowPos(arrow)
	local data=abh.localdb.profile.frames['ARROW'..self.bg .. arrow:GetUserData("faction")]
	if type(data.point)=="table" and tonumber(data.size) then
		print("valid data")
		arrow:SetSize(data.size)
		arrow:ClearAllPoints()
		arrow:SetPoint(unpack(data.point))
	else
		arrow:ClearAllPoints()
		if arrow:GetUserData("faction")=="Alliance" then
			arrow:SetPoint("TOPRIGHT",UIParent,"TOP",-100,-200)	
		else
			arrow:SetPoint("TOPLEFT",UIParent,"TOP",100,-200)	
		end
	end
end
function module:FlagTimer()
	if not CB then return end
	local bar=abh:BgTimer('FlagRespawn',23,L["Flag Respawn"],true)
	bar:ClearAllPoints()	
	bar:SetPoint("TOP",AlwaysUpFrame2,"BOTTOM",0,-10)
	bar:SetColor(C[bs:FriendFaction()]())
	bar:Start()
end
function module:Terminate()
	self:UnregisterAllMessages()
	if (acWidget) then acWidget:Release() end
	if (hcWidget) then hcWidget:Release() end
	acWidget=nil
	hcWidget=nil
	damagecounterstart=nil
	hArrow:Release()
	aArrow:Release()
end
function module:Config(short,long)
	abh:AddToggle("TPNOTIFY",true,L["Carrier notificaton"],L["Automatically inform raid when you target enemy flag carrier. Should not become spammy but test it"])
	abh:AddToggle("TPSPAM",false,L["Spam your life status"])
	abh:AddSlider("TPSPAMTHRESHOLD",20,10,80,L["Life percentage"],L["Under this life percentage you will start asking for help"])
	abh:AddToggle("TPB",true,L["Show warning buttons"],L["Displays the full panel with buttons for tactics"])
	abh:AddLabel(short .. " " ..L["Messages"],long .. " " .. L["Messages"],C.yellow)
	for title,subset in pairs(messages) do
		abh:AddSubLabel(L[title])
		for k,d in pairs(subset) do
			local ks=k..'shortcut'
			local v=d[1]
			abh:AddEdit(ks,k,L[v] .. ' ' .. L["shortcut"]).width="half"
			abh:AddEdit(k,v,L[v]).width="half"
		end
		abh:EndLabel()
	end
end
local function Announce(self)
	abh:Message(self:GetUserData("message"))
end
local function Tooltip(self)
	GameTooltip_AddNewbieTip(self.frame, self:GetUserData("message"), 1.0, 1.0, 1.0);	
end
function module:SetCarrier(obj,carrier,health,updated)
	if (not obj) then return end
	if (carrier) then
		health=tonumber(health) or 100
		updated=tonumber(updated) or 0
		local name,faction,race,class,localizedclass,health,updated=bs:GetInfo(carrier)
		--[===[@debug@
		print("Setting carrier to",name,carrier)
		--@end-debug@]===]
		name=name or carrier
		if (not InCombatLockdown()) then
			obj:SetMacrotext("/target " .. name)-- .. "\n/focus " .. name)
		end
		local formato=format("%s",name) .. " %d%% (%d " .. L["seconds old"] .. ")"
		obj:SetUserData("macro","/target " ..name)
		obj:SetUserData("race",race)
		obj:SetUserData("class",localizedclass)
		obj:SetUserData("format",formato)
		obj:SetUserData("health",health)
		obj:SetUserData("updated",updated)
		obj:SetUserData("taken",GetTime())
		obj:SetTitle(format(formato,health or 0,GetTime() - (updated or 0)))
		obj:SetTitleColor((C[class])())
		abh:debug("Setting icon to",IndexToTexCoord(classes[class],4))
		obj:SetImageCoord(IndexToTexCoord(classes[class],4))
	else
		obj.formato=nil
		obj:SetTitle(L['No Carrier'])
		obj:SetUserData("macro",nil)
		obj:SetUserData("race",nil)
		obj:SetUserData("class",nil)
		obj:SetUserData("format",nil)
		obj:SetUserData("health",nil)
		obj:SetUserData("updated",nil)
		obj:SetUserData("taken",nil)		
		obj:SetTitleColor(C.White())
		obj:SetImageCoord(IndexToTexCoord(11,4))
	end

end
function module:BATTLESCAN_HORDE_CARRIER_HEALTH(event,carrier,health,updated)
	hcWidget:SetUserData("health",health)
	hcWidget:SetUserData("updated",updated)
end
function module:BATTLESCAN_ALLIANCE_CARRIER_HEALTH(event,carrier,health,updated)
	acWidget:SetUserData("health",health)
	acWidget:SetUserData("updated",updated)
end
function module:BATTLESCAN_HORDE_CARRIER(event,carrier)
	self:SetCarrier(hcWidget,carrier)
	hCarrier=carrier or ""
end
function module:BATTLESCAN_ALLIANCE_CARRIER(event,carrier)
	self:SetCarrier(acWidget,carrier)
	aCarrier=carrier or ""
end
function module:SmartButton()
	local enemyCarrier=bs:FriendFaction()=="Alliance" and aCarrier or hCarrier
	if (UnitName("target") == enemyCarrier) then
		abh:Message(format(L["I am on enemy carrier %s. Help me!"],enemyCarrier))
	else
		self:Super().SmartButton(self)
	end
end
function module:ButtonRow(frame,label,messages,enemy,prefix)
	local g
	if (label) then
		g=AceGUI:Create("SimpleGroup")
		g:SetFullWidth(true)
		g:SetLayout("Flow")
		g:SetHeight(60)
		local l=AceGUI:Create("Label")
		l:SetText(label)
		l:SetWidth(65)
		l:SetColor((C[enemy and bs:EnemyFaction() or bs:FriendFaction()])())
		g:AddChild(l)
	else
		g=frame.children[#frame.children]
	end
	local b
	for _,k in pairs(messageorder) do
		local d=messages[k]
		if (d) then
			local v=d[1]
			local message=L[prefix..d[2]]
			b=AceGUI:Create("Button")
			local short,long=abh:GetString(k .. 'shortcut'),abh:GetString(k)		
			b:SetUserData("message",message ..' ' ..long)
			b:SetCallback("OnClick",Announce)
			b:SetCallback("OnEnter",Tooltip)
			b:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			b:SetText(short)
			b:SetWidth(65)
			b:SetHeight(20)
			g:AddChild(b)
		end
	end
	if (label) then
		frame:AddChild(g)
	end
end

--[[
AlwaysUpFrame2 ally
AlwaysUpFrame3 horde
--]]
